DISKLABEL(8)

NAME
disklabel - read and write disk pack label

SYNOPSIS
disklabel [-Acdtv] [-h | -p unit] [-T file] disk
disklabel -w [-Acdnv] [-T file] disk disktype [packid]
disklabel -e [-Acdnv] [-T file] disk
disklabel -E [-Acdnv] [-F|-f file] [-T file] disk
disklabel -R [-nv] [-F|-f file] disk protofile

DESCRIPTION
The disklabel utility can be used to install, examine, or modify the label on a disk drive or pack. The disk label contains information about disk characteristics (size, type, etc.) and the partition layout, stored on the disk itself. It is used by the operating system to optimize disk I/O and locate the filesystems resident on the disk.

disklabel supports 15 configurable partitions, ‘a’ through ‘p’, excluding ‘c’. The ‘c’ partition describes the entire physical disk, is automatically created by the kernel, and cannot be modified or deleted by disklabel. By convention, the ‘a’ partition of the boot disk is the root partition, and the ‘b’ partition of the boot disk is the swap partition, but all other letters can be used in any order for any other partitions as desired.

The options are as follows:

-A  Automatically allocate all the disk space in the OpenBSD portion of the disk in the recommended manner. See AUTOMATIC DISK ALLOCATION, below.

-c  Clear the system's in-core copy of the label and update it based on the on-disk label.

-d  Use the default label. This ignores any existing OpenBSD disk label on the disk.

-E  Use the built-in command-driven label editor described below.

-e  Edit an existing disk label using the editor specified in the EDITOR environment variable, or vi(1) if none is specified.

-F file
    Write entries to file in fstab(5) format for any partitions for which mount point information is known. The entries will be written using disklabel UIDs. The -F flag is only valid when used in conjunction with the -E or -R flags. If file already exists, it will be overwritten.

-f file
    The same as -F except that entries will be written using disk device names.

-h  Print partition sizes in human readable format.

-n  Make no permanent changes to the disklabel (useful for debugging purposes).

-p unit
    Print partition sizes in unit instead of sectors. Valid units are b(ytes), c(ylinders), k(ilobytes), m(egabytes), g(igabytes) and t(erabytes).

-R  Restore a disk label that was formatted in a prior operation and saved in an ASCII file.

-T file
    Read the template for automatic allocation from file instead of using the builtin one. See AUTOMATIC DISK ALLOCATION below for the format. If file is a single dash (‘-’), the template is read from the standard input.

-t  Format the label as a disktab(5) entry.

-v  Print additional information during operation (verbose mode).

-w  Write a standard label on the designated drive.

disk
    Specify the disk to operate on. It can be specified by its full pathname, by an abbreviated disk form, or by its disklabel UID. In its abbreviated form, the path to the device, the ‘r’ denoting "raw device", and the partition letter, can all be omitted. For example, the first IDE disk can be specified as either /dev/rwd0c, /dev/wd0c, or wd0.

disktype
    Specify a disktype entry from the disktab(5) database.

packid
    Specify a pack identification string for the device (see below).

protofile
    Used with the restore option (-R) to specify a file to read an ASCII label from.

The first form of the command (read) is used to examine the label on the named disk drive. It will display all of the parameters associated with the drive and its partition layout. The kernel's in-core copy of the label is displayed; if the disk has no label, or the partition types on the disk are incorrect, the kernel may have constructed or modified the label.

The second form of the command (write) is used to write a standard label on the designated drive. The drive parameters and partitions are taken from that file. If different disks of the same physical type are to have different partitions, it will be necessary to have separate disktab entries describing each, or to edit the label after installation as described below. The optional argument is a pack identification string, up to 16 characters long. The pack ID must be quoted if it contains blanks. The existing label will be updated via the in-core copy.

In the third form of the command (edit), the label is read from the in-core kernel copy and then supplied to an editor for changes. If no editor is specified in an EDITOR environment variable, vi(1) is used. When the editor terminates, the formatted label is reread and used to rewrite the disk label.

The built-in label editor (fourth form) provides a simple interactive label editor. The editor prompt contains information about the state of the edit process.

    disk*>

Where disk is the name of the disk being edited, ‘*’ means that the in-memory copy of the partition table has been modified but not yet written to disk.

Some commands or prompts take an optional unit. Available units are ‘b’ for bytes, ‘c’ for cylinders, ‘k’ for kilobytes, ‘m’ for megabytes, ‘g’ for gigabytes, and ‘t’ for terabytes. If no unit is given, the default is to use sectors (usually 512 bytes).

Quantities are rounded to the nearest cylinder when units are specified for sizes (or offsets). At prompts that request a size, ‘*’ may be entered to indicate the rest of the available space, ‘%’ for percentage of total, and ‘&’ for percentage free. Commands may be aborted by entering ‘^D’ (Control-D). Entering ‘^D’ at the main prompt will exit the editor.

The editor commands are as follows:

? | h
    Display help message with all available commands. There is also (simple) context-sensitive help available at most prompts.

A   Allocate all the disk space in the recommended manner. See AUTOMATIC DISK ALLOCATION, below.

a [part]
    Add new partition. This option adds a new partition to the disk label. If no partition letter is specified (a-p), the user will be prompted for one.

b   Set OpenBSD disk boundaries. This option tells disklabel which parts of the disk it is allowed to modify. This option is probably only useful for ports with fdisk(8) partition tables where the ending sector in the MBR is incorrect. The user may enter ‘*’ at the “Size” prompt to indicate the entire size of the disk (minus the starting sector). This is useful for disks where the fdisk partition table is incapable of storing the real size. Note: data may become corrupted if boundaries are extended such that they overlap with other resident operating systems.

c [part]
    Change the size of an existing partition. If no partition is specified, the user will be prompted for one. The new size may be in terms of the aforementioned units and may also be prefixed with ‘+’ or ‘-’ to change the size by a relative amount.

D   Sets the disk label to the default values as reported by the kernel. This simulates the case where there is no disk label.

d [part]
    Delete an existing partition (or ‘*’ to delete all partitions). If no partition is specified, the user will be prompted for one.

e   Edit label description, e.g. 'UMIS RPJTJ256MED'.

i   Change the disklabel UID, specified as a 16-character hexadecimal string. If set to all zeros, a new UID will automatically be allocated when the disklabel is written to disk.

l [unit]
    Print the disk label header.

M   Display this manual page. The manual page is piped through the pager specified by the PAGER environment variable or 'less' if PAGER is not set.

m [part]
    Modify parameters for an existing partition. If no partition is specified, the user will be prompted for one. This option allows the user to change the filesystem type, starting offset, partition size, and mount point for the specified partition.

n [part]
    Name the mount point for an existing partition. If no partition is specified, the user will be prompted for one. This option is only valid if disklabel was invoked with the -f flag.

p [unit]
    Print the current partition list. If a unit is given, the size and offsets are displayed in terms of the specified unit. If the unit is ‘*’, it is automatically determined by the size of the smallest partition.

q   Quit the editor. If any changes have been made, the user will be asked whether or not to save the changes to the on-disk label.

R [part]
    Resize a partition in an automatically allocated label, compacting unused space between partitions with a higher offset. The last partition will be shrunk if necessary. Works only for automatically allocated labels with no spoofed partitions.

r   Recalculate free space. This command displays all the free areas on the disk and the total number of free sectors.

s [path]
    Save the label to a file in ASCII format (suitable for loading via the -R option). If no path is specified, the user will be prompted for one.

U   Undo all changes made since entering the editor.

u   Undo (or redo) last change. Entering u once will undo the last change. Entering it again will restore the change.

w   Write the label to disk. This option will commit any changes to the on-disk label.

x   Exit the editor without saving any changes to the on-disk label.

z   Zero out the existing partition table and mount point information, leaving only the 'c' partition. The drive parameters are not changed.

In the restore form of the command (fifth form), the prototype file used to create the label should be in the same format as that produced when reading or editing a label. Comments are delimited by # and newline.

Note that when a disk has no real BSD disklabel, the kernel creates a default label so that the disk can be used. This default label will include other partitions found on the disk if they are supported on your architecture. For example, on systems that support fdisk(8) partitions the default label will also include DOS and Linux partitions. However, these entries are not dynamic, they are fixed at the time disklabel is run. That means that subsequent changes that affect non-OpenBSD partitions will not be present in the default label, though they may be updated by hand. To see the default label, run disklabel with the -d flag. disklabel can then be run with the -e flag and any entries pasted as desired from the default label into the real one.

AUTOMATIC DISK ALLOCATION
The -A option and the editor command A create disklabels that distribute a disk's free space into a set of partitions appropriate for an OpenBSD installation. The exact set of partitions created depends on available free space, how fragmented the free space is and some machine dependent variables, but will be approximately:
 | > 10GB Free | > 2.5GB | > 700MB | < 700MB
/ | 150MB –   1GB | 800MB –   2GB | 700MB –   4GB | 1MB – 2GB
swap | 80MB – 256MB | 80MB – 256MB | 1MB – 256MB |
/usr | 1.5GB –  30GB | 1.5GB –  30GB | |
/home | 1GB – 300GB | 256MB –   2GB | |
/tmp | 120MB –   4GB | | |
/var | 80MB –   4GB | | |
/usr/X11R6 | 384MB –   1GB | | |
/usr/local | 1GB –  20GB | | |
/usr/src | 2GB –   5GB | | |
/usr/obj | 8GB –  10GB | | |

The -A option displays the partition set that would be created and -wA writes it to disk.

The default set can be overridden with -T. Each line of input uses three fields to describe a partition. There must not be whitespace before the first field, fields are separated by whitespace and fields cannot contain whitespace.

The first field is the partition's mount point or one of the special tokens ‘RAID’ or ‘SWAP’.

The second field is the partition size. This can be ‘*’ to make the partition as large as possible, an exact size (e.g. 1G) or a size range (e.g. 1M-10G or 1G-*).

The third field is the partition's share of any space left after all minimum sizes are accounted for. This is expressed as a percentage from 0 (the default) to 100 (e.g. 37%). The last partition receives all remaining free space up to its maximum size no matter what percentage is specified.

FILES

/etc/disktab
    Disk description file.

EXAMPLES
Display, respectively, the current label, the default label and the default auto allocation for sd0:

    # disklabel sd0
    # disklabel -d sd0
    # disklabel -A sd0

Write the default auto allocation to sd0:

    # disklabel -wA sd0

Edit the label for the disk with DUID 3eb7f9da875cb9ee:

    # disklabel -E 3eb7f9da875cb9ee

Restore the label for sd0 from information in mylabel:

    # disklabel -R sd0 mylabel

Put largest contiguous area of free space on sd0 into a single RAID partition:
    # echo 'RAID *' | disklabel -wAT- sd0

Write the auto allocation defined in /template to sd0:

    # disklabel -wAT/template sd0

A template file that results in an auto allocation similar to the default one for a disk with 5GB of free space is:
/ | 800M–2G | 5%
swap | 80M–256M | 10%
/usr | 1300M–3G | 75%
/home | 256M–2G | 10%

DIAGNOSTICS
The kernel device drivers will not allow the size of a disk partition to be decreased or the offset of a partition to be changed while it is open. Some device drivers create a label containing only a single large partition if a disk is unlabeled; thus, the label must be written to the ‘a’ partition of the disk while it is open. This sometimes requires the desired label to be set in two steps, the first one creating at least one other partition, and the second setting the label on the new partition while shrinking the ‘a’ partition.

SEE ALSO
softraid(4), disklabel(5), disktab(5), installboot(8), scan_ffs(8)

HISTORY
The disklabel utility appeared in 4.3BSD Tahoe.

CAVEATS
The maximum disk and partition size is 64PB.

On some machines, such as Sparc64, partition tables may not exhibit the full functionality described above.